//+------------------------------------------------------------------+
//|                                                    Red&Black.mq4 |
//|                                 Copyright  2008, Gryb Alexander |
//|                                        http://minute-fx.narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Gryb Alexander"
#property link      "http://minute-fx.narod.ru"
#define MAGICNUMBER 10000

extern double lots = 1;

extern int numBars =3;
int slippage = 3;
datetime curTime;
int result;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
if((Time[0]!=curTime))
{   
   curTime=Time[0];

   if(OrdersTotal()>0)
   {
     OrderSelect(0,SELECT_BY_POS);
     if(OrderType()==OP_BUY)
              OrderClose(OrderTicket(),OrderLots(),Bid,3);
     if(OrderType()==OP_SELL)             
             OrderClose(OrderTicket(),OrderLots(),Ask,3);
   }
}
   if((OrdersTotal()==0) && (TimeHour(TimeCurrent())==0))
   {
     AnalizeHistory();
     if(result>0) OrderSend(Symbol(),OP_BUY,lots,Ask,slippage,0,0,"Expert buy position",MAGICNUMBER);    
     if(result<0) OrderSend(Symbol(),OP_SELL,lots,Bid,slippage,0,0,"Expert sell position",MAGICNUMBER); 
   }
//----
   return(0);
}
void AnalizeHistory()
{ 
  result = 0;
  int z=0; string curState="";
  string barsHist[100000];
  //   barHist   numBars 
  for(int k=Bars-(numBars+1);k>0;k--)
  { 
    for(int i=numBars;i>=0;i--)
    {
     if((Close[k+i]-Open[k+i])>0)
     {
       barsHist[z]=barsHist[z]+"1";
     }
     else
     {
       barsHist[z]=barsHist[z]+"0";
     }
    }
    z++;
    barsHist[z]="";
  }
  //  
  for(k=numBars;k>=1;k--)
  {
    if((Close[k]-Open[k])>0) curState=curState+"1"; else curState=curState+"0";
  }
  //  ,    
    
  for(k=1;k<=z;k++)
  {
    if(curState==StringSubstr(barsHist[k],1,numBars))
    {
      if(StringSubstr(barsHist[k],numBars,1)=="1") result++; else result--;
    }
  }
}
//+------------------------------------------------------------------+